//
// c o n s o l e . c
//
// GBA console driver
//
// June 22, 2003 by Wataru Nishida (http://www.skyfree.org)
//

#include "gba.h"
#include "screen.h"

void selectpage(int num) {
  if (num < 0)
    page = 0;
  else if (num >= 4)
    page = 3;
  else
    page = num;
 }

void locate(int xx, int yy) {
  if (xx < 0)
    scrn[ page ].x = 0;
  else if (xx >= LCD_RWIDTH)
    scrn[ page ].x = LCD_RWIDTH - 1;
  else
    scrn[ page ].x = xx;

  if (yy < 0)
    scrn[ page ].y = 0;
  else if (yy >= LCD_RHEIGHT)
    scrn[ page ].y = LCD_RHEIGHT - 1;
  else
    scrn[ page ].y = yy;
 }

static
void scrollup(void) {
  int i, j;

  for (i = 1; i < LCD_RHEIGHT; i++) {
    for (j = 0; j < LCD_RWIDTH; j++)
      scrn[ page ].map[ (i - 1) * LCD_VWIDTH + j ] = \
      scrn[ page ].map[ i * LCD_VWIDTH + j ];
   }
  for (j = 0; j < LCD_RWIDTH; j++)
    scrn[ page ].map[ 19 * LCD_VWIDTH + j ] = ' ';
 }

void clear(void) {
  int i, j;

  for (i = 0; i < LCD_RHEIGHT; i++) {
    for (j = 0; j < LCD_RWIDTH; j++)
      scrn[ page ].map[ i * LCD_VWIDTH + j ] = ' ';
   }
 }

void putchar(int ch) {
  if (ch == '\n') {
    scrn[ page ].x = 0;
    if (scrn[ page ].y < (LCD_RHEIGHT - 1))
      scrn[ page ].y++;
    else
      scrollup();
   }
  else {
    scrn[ page ].map[ scrn[ page ].y * LCD_VHEIGHT + scrn[ page ].x ] = ch;
    if (scrn[ page ].x < (LCD_RWIDTH - 1))
      scrn[ page ].x++;
    else {
      scrn[ page ].x = 0;
      if (scrn[ page ].y < (LCD_RHEIGHT - 1))
        scrn[ page ].y++;
      else
        scrollup();
     }
   }
 }
